//(c) 2020 by Steffen Roth
struct PS_INPUT
{
    float4 Position   : POSITION;
    float2 Texture    : TEXCOORD0;
};

struct PS_OUTPUT
{
    float4 Color   : COLOR0;
};

sampler2D Tex0;

int c;

float b;
float d;
float red;
float green;
float blue;

PS_OUTPUT ps_main( in PS_INPUT In )
{
    PS_OUTPUT Out;
    Out.Color = tex2D(Tex0, In.Texture);

	red = float(int((Out.Color.r *255) / c) * c) / 255;
	green = float(int((Out.Color.g *255) / c) * c) / 255;
	blue = float(int((Out.Color.b *255) / c) * c) / 255;

	if (red > b) red = 1;
	else if (red < d) red = 0;	
	if (green > b) green = 1;
	else if (green < d) green = 0;
	if (blue > b) blue = 1;
	else if (blue < d) blue = 0;
	
	Out.Color.r = red;
	Out.Color.g = green;
	Out.Color.b = blue;
	
    return Out;
}

technique tech_main
{
    pass P0
    {
        VertexShader = NULL;
        PixelShader  = compile ps_2_0 ps_main();
    }  
}